/*
  SDL Version 0.80

    2002/ 1/29  
*/

#include "SDL.h"
#include <stdio.h>

Uint32 *backbuf,*buttocks,*buttback,*hand,hx,hy;
SDL_Rect rectFore,rectBack,rectHand,rectTe;
SDL_Surface *window,*back,*te;
SDL_AudioSpec saSpec,saSound;
Uint8 *s_data,*s_pos;
Uint32 s_size,s_left;

void put_audio(void *userdata, Uint8 *stream, int len) {

	if (s_left<=0)
		return;

	if (len>s_left)
		len=s_left;

        SDL_MixAudio(stream,s_pos,len,SDL_MIX_MAXVOLUME);

	s_pos+=len;
	s_left-=len;

}

void spank(int x,int y) {

	int i,j,r,g,b,or,og,ob,xx,yy;

	if (SDL_GetMouseState(NULL,NULL) & SDL_BUTTON(1)==0)
	  return;

	s_left=s_size;
	s_pos=s_data;

	for (i=-40;i<40;i++)
		for (j=-60;j<60;j++) {

			xx=x+j;
			yy=y+i;

			if (xx>=0 && xx<450 && yy>=0 && yy<300 &&
			    buttocks[xx+yy*450]!=0x000000ff && i*i+j*j<2600) {

				r=(buttback[xx+yy*450] & 0x00ff0000) >> 16;
				g=(buttback[xx+yy*450] & 0x0000ff00) >> 8;
				b=buttback[xx+yy*450] & 0x000000ff;
				or=(buttocks[xx+yy*450] & 0x00ff0000) >> 16;
				og=(buttocks[xx+yy*450] & 0x0000ff00) >> 8;
				ob=buttocks[xx+yy*450] & 0x000000ff;

				r+=2;
				g-=1;
				b-=1;

				if (r>255)
					r=255;
				if (g<og*0.72)
					g=(int)(og*0.72);
				if (b<ob*0.72)
					b=(int)(ob*0.72);

				buttback[xx+yy*450]=(r << 16)+(g << 8)+b;

			}

		}

	SDL_OpenAudio(&saSpec,NULL);
	SDL_PauseAudio(0);

	while(s_left>0)
		SDL_Delay(10);

	SDL_CloseAudio();

	SDL_Delay(100);

}

int loadBMP(char *fn,Uint32 **pixels) {

	Uint8 *buf;
	int size,width,height,length,offset,i,j,p;

	FILE *fp=fopen(fn,"rb");

	fseek(fp,0,SEEK_END);
	size=ftell(fp)+1;
	rewind(fp);

	if (size<54) {

		fclose(fp);
		return 0;

	}

	buf=(Uint8 *)malloc(size);

	fread(buf,1,size,fp);
	fclose(fp);

	offset=*((int *)(buf+10));
	width=*((int *)(buf+18));
	height=*((int *)(buf+22));
	*pixels=(Uint32 *)malloc(width*height*4);

	if (width % 4==0)
		length=width*3;
	else
		length=width*3+(4-(width*3)%4);

	for (i=0;i<height;i++)
		for (j=0;j<width;j++) {

			p=j*3+(height-i-1)*length+offset;
			(*pixels)[j+i*width]=buf[p]+buf[p+1]*256+buf[p+2]*65536;

		}

	return width*height;

}

void draw() {

	memcpy(backbuf,buttback,450*300*4);
	SDL_BlitSurface(te,&rectTe,back,&rectHand);

	SDL_BlitSurface(back,&rectBack,window,&rectFore);

	SDL_UpdateRect(window,0,0,0,0);

}

int main(int arg,char *argv) {

	int quite=0,i;
	SDL_Event e;
	SDL_AudioSpec saTmp;
	SDL_AudioCVT cvt;

	if (SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO)!=0)
		exit(1);

	window=SDL_SetVideoMode(452,302,32,SDL_SWSURFACE);

	loadBMP("osiri.bmp",&buttocks);

	buttback=(Uint32 *)malloc(450*300*4);
	memcpy(buttback,buttocks,450*300*4);

	loadBMP("hand.bmp",&hand);

	backbuf=(Uint32 *)malloc(450*300*4);
	back=SDL_CreateRGBSurfaceFrom((void *)backbuf,450,300,32,450*4,
	       0x00ff0000,0x0000ff00,0x000000ff,0);

	te=SDL_CreateRGBSurfaceFrom((void *)hand,160,90,32,160*4,
	       0x00ff0000,0x0000ff00,0x000000ff,0);

	SDL_SetColorKey(te,SDL_SRCCOLORKEY,0x00ffffff);

	rectFore.x=1;
	rectFore.y=1;
	rectFore.w=450;
	rectFore.h=300;

	rectBack.x=0;
	rectBack.y=0;
	rectBack.w=450;
	rectBack.h=300;

	rectHand.x=0;
	rectHand.y=0;
	rectHand.w=160;
	rectHand.h=90;

	rectTe=rectHand;

	draw();

	saSpec.freq=22050;
	saSpec.format=AUDIO_S16;
	saSpec.channels=1;
	saSpec.samples=1024;
	saSpec.callback=put_audio;
	saSpec.userdata=NULL;

	SDL_LoadWAV("sp1.wav",&saTmp,&s_data,&s_size);

	SDL_BuildAudioCVT(&cvt,saTmp.format,saTmp.channels,saTmp.freq,
	                  saSpec.format,saSpec.channels,saSpec.freq);

	cvt.buf=(Uint8 *)malloc(s_size*cvt.len_mult);
	memcpy(cvt.buf,s_data,s_size);
	cvt.len=s_size;
	SDL_ConvertAudio(&cvt);
	SDL_FreeWAV(s_data);
	s_data=cvt.buf;
	s_size=cvt.len_cvt;

	while (quite==0) {

		SDL_WaitEvent(&e);

		switch (e.type) {

		case SDL_MOUSEMOTION:

			hx=e.motion.x;
			hy=e.motion.y;

			rectHand.x=hx-70;
			rectHand.y=hy-45;
			draw();

			if (hx<rectFore.x || hx>=rectFore.x+rectFore.w ||
			    hy<rectFore.y || hy>=rectFore.y+rectFore.h)
				SDL_ShowCursor(SDL_ENABLE);
			else
				SDL_ShowCursor(SDL_DISABLE);

			break;

		case SDL_MOUSEBUTTONDOWN:

			if (e.button.button==SDL_BUTTON_LEFT) {

				spank(e.button.x,e.button.y);
				draw();

			}

			break;

		case SDL_QUIT:

			quite=1;
			break;

		}

	}

	SDL_FreeSurface(back);
	SDL_FreeSurface(te);

	free(buttocks);
	free(hand);
	free(backbuf);
	free(s_data);

	SDL_Quit();

	return 0;

}
